//	Draw4D-Grid.fs

uniform sampler2D	uniTexture;	//	automatically initialized to 0

uniform float		uniOpacity;	//	∈ [0.0, 1.0]

const vec3	cntColor = vec3(1.0 - 1.0/8.0, 1.0 - 1.0/16.0, 1.0);

in float	varGrey;
in vec2		varGridCoords;

void main()
{
	float	tmpGridLightness,
			tmpGrey;

	tmpGridLightness	= texture(uniTexture, varGridCoords).r;
	tmpGrey				= varGrey * tmpGridLightness;
	
	gl_FragColor = uniOpacity * vec4(tmpGrey * cntColor, 1.0);	//	premultiplied (αR,αG,αB,α)
}
