//	Draw4D-Grid.vs

uniform vec3	uniScaleFactors;	//	scales position vectors, but not normal vectors
uniform mat4	uniModelViewMatrix,
				uniModelViewProjectionMatrix;
uniform vec3	uniDiffuseEvaluator,
				uniSpecularEvaluator;
uniform float	uniGridScale;

in vec3			atrPosition;
in vec3			atrNormal;
in vec2			atrGridCoords;

out float		varGrey;
out vec2		varGridCoords;

void main()
{
	vec3	tmpPosition;
	vec4	tmpWorldPosition;
	float	tmpFogFactor,
			tmpDiffuseFactor;

	tmpPosition			= atrPosition * uniScaleFactors;
	gl_Position			= uniModelViewProjectionMatrix * vec4(tmpPosition, 1.0);
	
	//	Don't really need full matrix computation, just z-component of the result.
	tmpWorldPosition	= uniModelViewMatrix * vec4(tmpPosition, 1.0);
	tmpFogFactor		= 0.125 * clamp(tmpWorldPosition.z, 0.0, 1.0);
	
	tmpDiffuseFactor	= 0.50 + 0.50 * max(0.0, dot(uniDiffuseEvaluator, atrNormal));

	varGrey				= (1.0 - tmpFogFactor) * tmpDiffuseFactor;
	varGridCoords		= uniGridScale * atrGridCoords;
}
